Index: uspace/lib/c/generic/vfs/vfs.c
===================================================================
--- uspace/lib/c/generic/vfs/vfs.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/generic/vfs/vfs.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -756,9 +756,8 @@
 {
 	struct stat stat;
-	
-	int rc = fstat(fildes, &stat);
-	if (rc != 0)
-		return rc;
-	
+	int rc;
+
+	rc = fstat(fildes, &stat);
+
 	if (!stat.device)
 		return -1;
Index: uspace/lib/c/include/adt/generic_char_map.h
===================================================================
--- uspace/lib/c/include/adt/generic_char_map.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/include/adt/generic_char_map.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -47,8 +47,4 @@
 #define GENERIC_CHAR_MAP_MAGIC_VALUE	0x12345622
 
-/** Generic destructor function pointer. */
-#define DTOR_T(identifier) \
-	void (*identifier)(const void *)
-
 /** Character string to generic type map declaration.
  *  @param[in] name	Name of the map.
@@ -68,6 +64,6 @@
 	int name##_add(name##_t *, const uint8_t *, const size_t, type *); \
 	int name##_count(name##_t *); \
-	void name##_destroy(name##_t *, DTOR_T()); \
-	void name##_exclude(name##_t *, const uint8_t *, const size_t, DTOR_T()); \
+	void name##_destroy(name##_t *); \
+	void name##_exclude(name##_t *, const uint8_t *, const size_t); \
 	type *name##_find(name##_t *, const uint8_t *, const size_t); \
 	int name##_initialize(name##_t *); \
@@ -88,4 +84,5 @@
 	     type *value) \
 	{ \
+		int rc; \
 		int index; \
 		if (!name##_is_valid(map)) \
@@ -94,5 +91,10 @@
 		if (index < 0) \
 			return index; \
-		return char_map_add(&map->names, name, length, index); \
+		rc = char_map_add(&map->names, name, length, index); \
+		if (rc != EOK) { \
+			name##_items_exclude_index(&map->values, index); \
+			return rc; \
+		} \
+		return EOK; \
 	} \
 	\
@@ -103,14 +105,14 @@
 	} \
 	\
-	void name##_destroy(name##_t *map, DTOR_T(dtor)) \
+	void name##_destroy(name##_t *map) \
 	{ \
 		if (name##_is_valid(map)) { \
 			char_map_destroy(&map->names); \
-			name##_items_destroy(&map->values, dtor); \
+			name##_items_destroy(&map->values); \
 		} \
 	} \
 	\
 	void name##_exclude(name##_t *map, const uint8_t *name, \
-	    const size_t length, DTOR_T(dtor)) \
+	    const size_t length) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -119,5 +121,5 @@
 			if (index != CHAR_MAP_NULL) \
 				name##_items_exclude_index(&map->values, \
-				     index, dtor); \
+				     index); \
 		} \
 	} \
Index: uspace/lib/c/include/adt/generic_field.h
===================================================================
--- uspace/lib/c/include/adt/generic_field.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/include/adt/generic_field.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -46,8 +46,4 @@
 #define GENERIC_FIELD_MAGIC_VALUE		0x55667788
 
-/** Generic destructor function pointer. */
-#define DTOR_T(identifier) \
-	void (*identifier)(const void *)
-
 /** Generic type field declaration.
  *
@@ -67,6 +63,6 @@
 	int name##_add(name##_t *, type *); \
 	int name##_count(name##_t *); \
-	void name##_destroy(name##_t *, DTOR_T()); \
-	void name##_exclude_index(name##_t *, int, DTOR_T()); \
+	void name##_destroy(name##_t *); \
+	void name##_exclude_index(name##_t *, int); \
 	type **name##_get_field(name##_t *); \
 	type *name##_get_index(name##_t *, int); \
@@ -107,14 +103,12 @@
 	} \
 	\
-	void name##_destroy(name##_t *field, DTOR_T(dtor)) \
+	void name##_destroy(name##_t *field) \
 	{ \
 		if (name##_is_valid(field)) { \
 			int index; \
 			field->magic = 0; \
-			if (dtor) { \
-				for (index = 0; index < field->next; index++) { \
-					if (field->items[index]) \
-						dtor(field->items[index]); \
-				} \
+			for (index = 0; index < field->next; index++) { \
+				if (field->items[index]) \
+					free(field->items[index]); \
 			} \
 			free(field->items); \
@@ -122,10 +116,9 @@
 	} \
 	 \
-	void name##_exclude_index(name##_t *field, int index, DTOR_T(dtor)) \
+	void name##_exclude_index(name##_t *field, int index) \
 	{ \
 		if (name##_is_valid(field) && (index >= 0) && \
 		    (index < field->next) && (field->items[index])) { \
-			if (dtor) \
-				dtor(field->items[index]); \
+			free(field->items[index]); \
 			field->items[index] = NULL; \
 		} \
Index: uspace/lib/c/include/adt/int_map.h
===================================================================
--- uspace/lib/c/include/adt/int_map.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/include/adt/int_map.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -49,8 +49,4 @@
 #define INT_MAP_ITEM_MAGIC_VALUE	0x55667788
 
-/** Generic destructor function pointer. */
-#define DTOR_T(identifier) \
-	void (*identifier)(const void *)
-
 /** Integer to generic type map declaration.
  *
@@ -76,9 +72,9 @@
 	\
 	int name##_add(name##_t *, int, type *); \
-	void name##_clear(name##_t *, DTOR_T()); \
+	void name##_clear(name##_t *); \
 	int name##_count(name##_t *); \
-	void name##_destroy(name##_t *, DTOR_T()); \
-	void name##_exclude(name##_t *, int, DTOR_T()); \
-	void name##_exclude_index(name##_t *, int, DTOR_T()); \
+	void name##_destroy(name##_t *); \
+	void name##_exclude(name##_t *, int); \
+	void name##_exclude_index(name##_t *, int); \
 	type *name##_find(name##_t *, int); \
 	int name##_update(name##_t *, int, int); \
@@ -86,5 +82,5 @@
 	int name##_initialize(name##_t *); \
 	int name##_is_valid(name##_t *); \
-	void name##_item_destroy(name##_item_t *, DTOR_T()); \
+	void name##_item_destroy(name##_item_t *); \
 	int name##_item_is_valid(name##_item_t *);
 
@@ -119,5 +115,5 @@
 	} \
 	\
-	void name##_clear(name##_t *map, DTOR_T(dtor)) \
+	void name##_clear(name##_t *map) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -126,5 +122,5 @@
 				if (name##_item_is_valid(&map->items[index])) { \
 					name##_item_destroy( \
-					    &map->items[index], dtor); \
+					    &map->items[index]); \
 				} \
 			} \
@@ -139,5 +135,5 @@
 	} \
 	\
-	void name##_destroy(name##_t *map, DTOR_T(dtor)) \
+	void name##_destroy(name##_t *map) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -147,5 +143,5 @@
 				if (name##_item_is_valid(&map->items[index])) { \
 					name##_item_destroy( \
-					    &map->items[index], dtor); \
+					    &map->items[index]); \
 				} \
 			} \
@@ -154,5 +150,5 @@
 	} \
 	\
-	void name##_exclude(name##_t *map, int key, DTOR_T(dtor)) \
+	void name##_exclude(name##_t *map, int key) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -162,16 +158,16 @@
 				    (map->items[index].key == key)) { \
 					name##_item_destroy( \
-					    &map->items[index], dtor); \
-				} \
-			} \
-		} \
-	} \
-	\
-	void name##_exclude_index(name##_t *map, int index, DTOR_T(dtor)) \
+					    &map->items[index]); \
+				} \
+			} \
+		} \
+	} \
+	\
+	void name##_exclude_index(name##_t *map, int index) \
 	{ \
 		if (name##_is_valid(map) && (index >= 0) && \
 		    (index < map->next) && \
 		    name##_item_is_valid(&map->items[index])) { \
-			name##_item_destroy(&map->items[index], dtor); \
+			name##_item_destroy(&map->items[index]); \
 		} \
 	} \
@@ -240,11 +236,10 @@
 	} \
 	\
-	void name##_item_destroy(name##_item_t *item, DTOR_T(dtor)) \
+	void name##_item_destroy(name##_item_t *item) \
 	{ \
 		if (name##_item_is_valid(item)) { \
 			item->magic = 0; \
 			if (item->value) { \
-				if (dtor) \
-					dtor(item->value); \
+				free(item->value); \
 				item->value = NULL; \
 			} \
Index: uspace/lib/c/include/devman.h
===================================================================
--- uspace/lib/c/include/devman.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/include/devman.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -53,6 +53,4 @@
 extern int devman_device_get_handle(const char *, devman_handle_t *,
     unsigned int);
-extern int devman_device_get_handle_by_class(const char *, const char *,
-    devman_handle_t *, unsigned int);
 
 extern int devman_add_device_to_class(devman_handle_t, const char *);
Index: uspace/lib/c/include/ipc/devman.h
===================================================================
--- uspace/lib/c/include/ipc/devman.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/include/ipc/devman.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -148,6 +148,5 @@
 
 typedef enum {
-	DEVMAN_DEVICE_GET_HANDLE = IPC_FIRST_USER_METHOD,
-	DEVMAN_DEVICE_GET_HANDLE_BY_CLASS
+	DEVMAN_DEVICE_GET_HANDLE = IPC_FIRST_USER_METHOD
 } client_to_devman_t;
 
Index: uspace/lib/c/include/ipc/services.h
===================================================================
--- uspace/lib/c/include/ipc/services.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/c/include/ipc/services.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -47,5 +47,8 @@
 	SERVICE_DEVMAP,
 	SERVICE_DEVMAN,
-	SERVICE_IRC,
+	SERVICE_FHC,
+	SERVICE_OBIO,
+	SERVICE_APIC,
+	SERVICE_I8259,
 	SERVICE_CLIPBOARD,
 	SERVICE_NETWORKING,
Index: uspace/lib/drv/Makefile
===================================================================
--- uspace/lib/drv/Makefile	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/drv/Makefile	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -35,5 +35,4 @@
 	generic/driver.c \
 	generic/dev_iface.c \
-	generic/log.c \
 	generic/remote_hw_res.c \
 	generic/remote_char_dev.c
Index: uspace/lib/drv/generic/driver.c
===================================================================
--- uspace/lib/drv/generic/driver.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/drv/generic/driver.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -273,6 +273,12 @@
 	
 	res = driver->driver_ops->add_device(dev);
-	if (res != EOK)
+	if (res == EOK) {
+		printf("%s: new device with handle=%" PRIun " was added.\n",
+		    driver->name, dev_handle);
+	} else {
+		printf("%s: failed to add a new device with handle = %" PRIun ".\n",
+		    driver->name, dev_handle);
 		delete_device(dev);
+	}
 	
 	async_answer_0(iid, res);
@@ -402,5 +408,5 @@
 			    get_remote_method(rem_iface, iface_method_idx);
 			if (iface_method_ptr == NULL) {
-				/* The interface has not such method */
+				// the interface has not such method
 				printf("%s: driver_connection_gen error - "
 				    "invalid interface method.", driver->name);
Index: uspace/lib/fs/libfs.c
===================================================================
--- uspace/lib/fs/libfs.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/fs/libfs.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -391,6 +391,4 @@
 						if (lflag & L_CREATE)
 							(void) ops->destroy(fn);
-						else
-							(void) ops->node_put(fn);
 						async_answer_0(rid, rc);
 					} else {
@@ -475,6 +473,4 @@
 					if (lflag & L_CREATE)
 						(void) ops->destroy(fn);
-					else
-						(void) ops->node_put(fn);
 					async_answer_0(rid, rc);
 				} else {
Index: uspace/lib/net/generic/generic.c
===================================================================
--- uspace/lib/net/generic/generic.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/net/generic/generic.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -106,5 +106,5 @@
 		return EBADMEM;
 
-	/* Request the address */
+	// request the address
 	message_id = async_send_1(phone, (sysarg_t) message,
 	    (sysarg_t) device_id, NULL);
@@ -112,7 +112,7 @@
 	async_wait_for(message_id, &result);
 
-	/* If not successful */
+	// if not successful
 	if ((string == EOK) && (result != EOK)) {
-		/* Clear the data */
+		// clear the data
 		free(*address);
 		free(*data);
@@ -242,5 +242,5 @@
 		return EBADMEM;
 
-	/* Request the translation */
+	// request the translation
 	message_id = async_send_3(phone, (sysarg_t) message,
 	    (sysarg_t) device_id, (sysarg_t) count, (sysarg_t) service, NULL);
@@ -249,7 +249,7 @@
 	async_wait_for(message_id, &result);
 
-	/* If not successful */
+	// if not successful
 	if ((string == EOK) && (result != EOK)) {
-		/* Clear the data */
+		// clear the data
 		free(*translation);
 		free(*data);
Index: uspace/lib/net/generic/net_checksum.c
===================================================================
--- uspace/lib/net/generic/net_checksum.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/net/generic/net_checksum.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -52,5 +52,5 @@
 uint16_t compact_checksum(uint32_t sum)
 {
-	/* Shorten to the 16 bits */
+	// shorten to the 16 bits
 	while (sum >> 16)
 		sum = (sum & 0xffff) + (sum >> 16);
@@ -72,9 +72,9 @@
 	size_t index;
 
-	/* Sum all the 16 bit fields */
+	// sum all the 16 bit fields
 	for (index = 0; index + 1 < length; index += 2)
 		seed += (data[index] << 8) + data[index + 1];
 
-	/* Last odd byte with zero padding */
+	// last odd byte with zero padding
 	if (index + 1 == length)
 		seed += data[index] << 8;
@@ -94,39 +94,39 @@
 	size_t index;
 
-	/* Process full bytes */
+	// process full bytes
 	while (length >= 8) {
-		/* Add the data */
+		// add the data
 		seed ^= (*data) << 24;
 		
-		/* For each added bit */
+		// for each added bit
 		for (index = 0; index < 8; ++index) {
-			/* If the first bit is set */
+			// if the first bit is set
 			if (seed & 0x80000000) {
-				/* Shift and divide the checksum */
+				// shift and divide the checksum
 				seed = (seed << 1) ^ ((uint32_t) CRC_DIVIDER_BE);
 			} else {
-				/* shift otherwise */
+				// shift otherwise
 				seed <<= 1;
 			}
 		}
 		
-		/* Move to the next byte */
+		// move to the next byte
 		++data;
 		length -= 8;
 	}
 
-	/* Process the odd bits */
+	// process the odd bits
 	if (length > 0) {
-		/* Add the data with zero padding */
+		// add the data with zero padding
 		seed ^= ((*data) & (0xff << (8 - length))) << 24;
 		
-		/* For each added bit */
+		// for each added bit
 		for (index = 0; index < length; ++index) {
-			/* If the first bit is set */
+			// if the first bit is set
 			if (seed & 0x80000000) {
-				/* Shift and divide the checksum */
+				// shift and divide the checksum
 				seed = (seed << 1) ^ ((uint32_t) CRC_DIVIDER_BE);
 			} else {
-				/* Shift otherwise */
+				// shift otherwise
 				seed <<= 1;
 			}
@@ -148,38 +148,38 @@
 	size_t index;
 
-	/* Process full bytes */
+	// process full bytes
 	while (length >= 8) {
-		/* Add the data */
+		// add the data
 		seed ^= (*data);
 		
-		/* For each added bit */
+		// for each added bit
 		for (index = 0; index < 8; ++index) {
-			/* If the last bit is set */
+			// if the last bit is set
 			if (seed & 1) {
-				/* Shift and divide the checksum */
+				// shift and divide the checksum
 				seed = (seed >> 1) ^ ((uint32_t) CRC_DIVIDER_LE);
 			} else {
-				/* Shift otherwise */
+				// shift otherwise
 				seed >>= 1;
 			}
 		}
 		
-		/* Move to the next byte */
+		// move to the next byte
 		++data;
 		length -= 8;
 	}
 
-	/* Process the odd bits */
+	// process the odd bits
 	if (length > 0) {
-		/* Add the data with zero padding */
+		// add the data with zero padding
 		seed ^= (*data) >> (8 - length);
 		
 		for (index = 0; index < length; ++index) {
-			/* If the last bit is set */
+			// if the last bit is set
 			if (seed & 1) {
-				/* Shift and divide the checksum */
+				// shift and divide the checksum
 				seed = (seed >> 1) ^ ((uint32_t) CRC_DIVIDER_LE);
 			} else {
-				/* Shift otherwise */
+				// shift otherwise
 				seed >>= 1;
 			}
@@ -198,5 +198,5 @@
 uint16_t flip_checksum(uint16_t checksum)
 {
-	/* Flip, zero is returned as 0xFFFF (not flipped) */
+	// flip, zero is returned as 0xFFFF (not flipped)
 	checksum = ~checksum;
 	return checksum ? checksum : IP_CHECKSUM_ZERO;
@@ -216,5 +216,5 @@
 uint16_t ip_checksum(uint8_t *data, size_t length)
 {
-	/* Compute, compact and flip the data checksum */
+	// compute, compact and flip the data checksum
 	return flip_checksum(compact_checksum(compute_checksum(0, data,
 	    length)));
Index: uspace/lib/net/generic/packet_client.c
===================================================================
--- uspace/lib/net/generic/packet_client.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/net/generic/packet_client.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -267,5 +267,5 @@
 		return NULL;
 
-	/* Get a new packet */
+	// get a new packet
 	copy = packet_get_4_remote(phone, PACKET_DATA_LENGTH(packet),
 	    PACKET_MAX_ADDRESS_LENGTH(packet), packet->max_prefix,
@@ -274,10 +274,10 @@
 		return NULL;
 
-	/* Get addresses */
+	// get addresses
 	addrlen = packet_get_addr(packet, &src, &dest);
-	/* Copy data */
+	// copy data
 	if ((packet_copy_data(copy, packet_get_data(packet),
 	    PACKET_DATA_LENGTH(packet)) == EOK) &&
-	    /* Copy addresses if present */
+	    // copy addresses if present
 	    ((addrlen <= 0) ||
 	    (packet_set_addr(copy, src, dest, addrlen) == EOK))) {
Index: uspace/lib/net/il/ip_client.c
===================================================================
--- uspace/lib/net/il/ip_client.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/net/il/ip_client.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -123,5 +123,5 @@
 		return EOK;
 
-	/* TODO IPv6 */
+	// TODO IPv6
 /*	case AF_INET6:
 		if (addrlen != sizeof(struct sockaddr_in6))
@@ -159,8 +159,6 @@
 	size_t padding;
 
-	/*
-	 * Compute the padding if IP options are set
-	 * multiple of 4 bytes
-	 */
+	// compute the padding if IP options are set
+	// multiple of 4 bytes
 	padding =  ipopt_length % 4;
 	if (padding) {
@@ -169,14 +167,14 @@
 	}
 
-	/* Prefix the header */
+	// prefix the header
 	data = (uint8_t *) packet_prefix(packet, sizeof(ip_header_t) + padding);
 	if (!data)
 		return ENOMEM;
 
-	/* Add the padding */
+	// add the padding
 	while (padding--)
 		data[sizeof(ip_header_t) + padding] = IPOPT_NOOP;
 
-	/* Set the header */
+	// set the header
 	header = (ip_header_t *) data;
 	header->header_length = IP_COMPUTE_HEADER_LENGTH(sizeof(ip_header_t) +
@@ -258,5 +256,5 @@
 		header_in->data_length = htons(data_length);
 		return EOK;
-	/* TODO IPv6 */
+	// TODO IPv6
 	} else {
 		return EINVAL;
Index: uspace/lib/net/include/ip_client.h
===================================================================
--- uspace/lib/net/include/ip_client.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/net/include/ip_client.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -54,5 +54,5 @@
     socklen_t, struct sockaddr *, socklen_t, size_t, void **, size_t *);
 
-/* TODO ipopt manipulation */
+// TODO ipopt manipulation
 
 #endif
Index: uspace/lib/net/tl/icmp_client.c
===================================================================
--- uspace/lib/net/tl/icmp_client.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/net/tl/icmp_client.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -81,5 +81,5 @@
 		*mtu = header->un.frag.mtu;
 
-	/* Remove debug dump */
+	// remove debug dump
 #ifdef CONFIG_DEBUG
 	printf("ICMP error %d (%d) in packet %d\n", header->type, header->code,
Index: uspace/lib/net/tl/socket_core.c
===================================================================
--- uspace/lib/net/tl/socket_core.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/net/tl/socket_core.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -91,11 +91,11 @@
 	int packet_id;
 
-	/* If bound */
+	// if bound
 	if (socket->port) {
-		/* Release the port */
+		// release the port
 		socket_port_release(global_sockets, socket);
 	}
 	
-	/* Release all received packets */
+	// release all received packets
 	while ((packet_id = dyn_fifo_pop(&socket->received)) >= 0)
 		pq_release_remote(packet_phone, packet_id);
@@ -107,5 +107,5 @@
 		socket_release(socket);
 
-	socket_cores_exclude(local_sockets, socket->socket_id, free);
+	socket_cores_exclude(local_sockets, socket->socket_id);
 }
 
@@ -166,5 +166,5 @@
 	int rc;
 
-	/* Create a wrapper */
+	// create a wrapper
 	socket_ref = malloc(sizeof(*socket_ref));
 	if (!socket_ref)
@@ -172,5 +172,5 @@
 
 	*socket_ref = socket;
-	/* Add the wrapper */
+	// add the wrapper
 	rc = socket_port_map_add(&socket_port->map, key, key_length,
 	    socket_ref);
@@ -206,5 +206,5 @@
 	int rc;
 
-	/* Create a wrapper */
+	// create a wrapper
 	socket_port = malloc(sizeof(*socket_port));
 	if (!socket_port)
@@ -221,5 +221,5 @@
 		goto fail;
 	
-	/* Register the incoming port */
+	// register the incomming port
 	rc = socket_ports_add(global_sockets, port, socket_port);
 	if (rc < 0)
@@ -230,5 +230,5 @@
 
 fail:
-	socket_port_map_destroy(&socket_port->map, free);
+	socket_port_map_destroy(&socket_port->map);
 	free(socket_port);
 	return rc;
@@ -277,25 +277,25 @@
 		
 		address_in = (struct sockaddr_in *) addr;
-		/* Find the socket */
+		// find the socket
 		socket = socket_cores_find(local_sockets, socket_id);
 		if (!socket)
 			return ENOTSOCK;
 		
-		/* Bind a free port? */
+		// bind a free port?
 		if (address_in->sin_port <= 0)
 			return socket_bind_free_port(global_sockets, socket,
 			     free_ports_start, free_ports_end, last_used_port);
 		
-		/* Try to find the port */
+		// try to find the port
 		socket_port = socket_ports_find(global_sockets,
 		    ntohs(address_in->sin_port));
 		if (socket_port) {
-			/* Already used */
+			// already used
 			return EADDRINUSE;
 		}
 		
-		/* If bound */
+		// if bound
 		if (socket->port) {
-			/* Release the port */
+			// release the port
 			socket_port_release(global_sockets, socket);
 		}
@@ -306,5 +306,5 @@
 		
 	case AF_INET6:
-		/* TODO IPv6 */
+		// TODO IPv6
 		break;
 	}
@@ -333,5 +333,5 @@
 	int index;
 
-	/* From the last used one */
+	// from the last used one
 	index = last_used_port;
 	
@@ -339,18 +339,18 @@
 		++index;
 		
-		/* Till the range end */
+		// til the range end
 		if (index >= free_ports_end) {
-			/* Start from the range beginning */
+			// start from the range beginning
 			index = free_ports_start - 1;
 			do {
 				++index;
-				/* Till the last used one */
+				// til the last used one
 				if (index >= last_used_port) {
-					/* None found */
+					// none found
 					return ENOTCONN;
 				}
 			} while (socket_ports_find(global_sockets, index));
 			
-			/* Found, break immediately */
+			// found, break immediately
 			break;
 		}
@@ -384,5 +384,5 @@
 			socket_id = 1;
 			++count;
-		/* Only this branch for last_id */
+		// only this branch for last_id
 		} else {
 			if (socket_id < INT_MAX) {
@@ -425,5 +425,5 @@
 		return EINVAL;
 	
-	/* Store the socket */
+	// store the socket
 	if (*socket_id <= 0) {
 		positive = (*socket_id == 0);
@@ -441,5 +441,5 @@
 		return ENOMEM;
 	
-	/* Initialize */
+	// initialize
 	socket->phone = app_phone;
 	socket->port = -1;
@@ -493,10 +493,10 @@
 	int accepted_id;
 
-	/* Find the socket */
+	// find the socket
 	socket = socket_cores_find(local_sockets, socket_id);
 	if (!socket)
 		return ENOTSOCK;
 	
-	/* Destroy all accepted sockets */
+	// destroy all accepted sockets
 	while ((accepted_id = dyn_fifo_pop(&socket->accepted)) >= 0)
 		socket_destroy(packet_phone, accepted_id, local_sockets,
@@ -535,13 +535,13 @@
 	next_packet = pq_next(packet);
 	if (!next_packet) {
-		/* Write all if only one fragment */
+		// write all if only one fragment
 		rc = data_reply(packet_get_data(packet),
 		    packet_get_data_length(packet));
 		if (rc != EOK)
 			return rc;
-		/* Store the total length */
+		// store the total length
 		*length = packet_get_data_length(packet);
 	} else {
-		/* Count the packet fragments */
+		// count the packet fragments
 		fragments = 1;
 		next_packet = pq_next(packet);
@@ -549,5 +549,5 @@
 			++fragments;
 		
-		/* Compute and store the fragment lengths */
+		// compute and store the fragment lengths
 		lengths = (size_t *) malloc(sizeof(size_t) * fragments +
 		    sizeof(size_t));
@@ -565,5 +565,5 @@
 		}
 		
-		/* Write the fragment lengths */
+		// write the fragment lengths
 		rc = data_reply(lengths, sizeof(int) * (fragments + 1));
 		if (rc != EOK) {
@@ -573,5 +573,5 @@
 		next_packet = packet;
 		
-		/* Write the fragments */
+		// write the fragments
 		for (index = 0; index < fragments; ++index) {
 			rc = data_reply(packet_get_data(next_packet),
@@ -584,5 +584,5 @@
 		}
 		
-		/* Store the total length */
+		// store the total length
 		*length = lengths[fragments];
 		free(lengths);
@@ -636,8 +636,8 @@
 		return;
 	
-	/* Find ports */
+	// find ports
 	socket_port = socket_ports_find(global_sockets, socket->port);
 	if (socket_port) {
-		/* Find the socket */
+		// find the socket
 		socket_ref = socket_port_map_find(&socket_port->map,
 		    socket->key, socket->key_length);
@@ -646,15 +646,15 @@
 			--socket_port->count;
 			
-			/* Release if empty */
+			// release if empty
 			if (socket_port->count <= 0) {
-				/* Destroy the map */
-				socket_port_map_destroy(&socket_port->map, free);
-				/* Release the port */
+				// destroy the map
+				socket_port_map_destroy(&socket_port->map);
+				// release the port
 				socket_ports_exclude(global_sockets,
-				    socket->port, free);
+				    socket->port);
 			} else {
-				/* Remove */
+				// remove
 				socket_port_map_exclude(&socket_port->map,
-				    socket->key, socket->key_length, free);
+				    socket->key, socket->key_length);
 			}
 		}
@@ -685,10 +685,10 @@
 	int rc;
 
-	/* Find ports */
+	// find ports
 	socket_port = socket_ports_find(global_sockets, port);
 	if (!socket_port)
 		return ENOENT;
 	
-	/* Add the socket */
+	// add the socket
 	rc = socket_port_add_core(socket_port, socket, key, key_length);
 	if (rc != EOK)
Index: uspace/lib/net/tl/tl_common.c
===================================================================
--- uspace/lib/net/tl/tl_common.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/net/tl/tl_common.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -182,5 +182,5 @@
 			else
 				packet_dimensions_exclude(packet_dimensions,
-				    DEVICE_INVALID_ID, free);
+				    DEVICE_INVALID_ID);
 		}
 	}
@@ -255,5 +255,5 @@
 	int length;
 
-	/* Detach the first packet and release the others */
+	// detach the first packet and release the others
 	next = pq_detach(packet);
 	if (next)
@@ -262,8 +262,6 @@
 	length = packet_get_addr(packet, &src, NULL);
 	if ((length > 0) && (!error) && (icmp_phone >= 0) &&
-	    /*
-	     * Set both addresses to the source one (avoids the source address
-	     * deletion before setting the destination one)
-	     */
+	    // set both addresses to the source one (avoids the source address
+	    // deletion before setting the destination one)
 	    (packet_set_addr(packet, src, src, (size_t) length) == EOK)) {
 		return EOK;
@@ -301,9 +299,9 @@
 		return EINVAL;
 
-	/* Get the data length */
+	// get the data length
 	if (!async_data_write_receive(&callid, &length))
 		return EINVAL;
 
-	/* Get a new packet */
+	// get a new packet
 	*packet = packet_get_4_remote(packet_phone, length, dimension->addr_len,
 	    prefix + dimension->prefix, dimension->suffix);
@@ -311,5 +309,5 @@
 		return ENOMEM;
 
-	/* Allocate space in the packet */
+	// allocate space in the packet
 	data = packet_suffix(*packet, length);
 	if (!data) {
@@ -318,5 +316,5 @@
 	}
 
-	/* Read the data into the packet */
+	// read the data into the packet
 	rc = async_data_write_finalize(callid, data, length);
 	if (rc != EOK) {
@@ -325,5 +323,5 @@
 	}
 	
-	/* Set the packet destination address */
+	// set the packet destination address
 	rc = packet_set_addr(*packet, NULL, (uint8_t *) addr, addrlen);
 	if (rc != EOK) {
Index: uspace/lib/packet/generic/packet_server.c
===================================================================
--- uspace/lib/packet/generic/packet_server.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/packet/generic/packet_server.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -112,9 +112,9 @@
     size_t max_content, size_t max_suffix)
 {
-	/* Clear the packet content */
+	// clear the packet content
 	bzero(((void *) packet) + sizeof(packet_t),
 	    packet->length - sizeof(packet_t));
 	
-	/* Clear the packet header */
+	// clear the packet header
 	packet->order = 0;
 	packet->metric = 0;
@@ -151,5 +151,5 @@
 	assert(fibril_mutex_is_locked(&ps_globals.lock));
 
-	/* Already locked */
+	// already locked
 	packet = (packet_t *) mmap(NULL, length, PROTO_READ | PROTO_WRITE,
 	    MAP_SHARED | MAP_ANONYMOUS, 0, 0);
Index: uspace/lib/softint/generic/multiplication.c
===================================================================
--- uspace/lib/softint/generic/multiplication.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/lib/softint/generic/multiplication.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -109,5 +109,5 @@
 	 * result does not fit in signed one */
 	if (SOFTINT_CHECK_OF && ((t2 < t1) || (t2 & (1ull << 63)))) {
-		/* Error, overflow */
+		// error, overflow
 		return (neg ? INT64_MIN : INT64_MAX);
 	}
Index: uspace/srv/bd/ata_bd/ata_bd.c
===================================================================
--- uspace/srv/bd/ata_bd/ata_bd.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/bd/ata_bd/ata_bd.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -372,5 +372,4 @@
 	uint16_t w;
 	uint8_t c;
-	uint16_t bc;
 	size_t pos, len;
 	int rc;
@@ -388,24 +387,11 @@
 	} else if (rc == EIO) {
 		/*
-		 * There is something, but not a register device. Check to see
-		 * whether the IDENTIFY command left the packet signature in
-		 * the registers in case this is a packet device.
-		 *
-		 * According to the ATA specification, the LBA low and
-		 * interrupt reason registers should be set to 0x01. However,
-		 * there are many devices that do not follow this and only set
-		 * the byte count registers. So, only check these.
+		 * There is something, but not a register device.
+		 * It could be a packet device.
 		 */
-		bc = ((uint16_t)pio_read_8(&cmd->cylinder_high) << 8) |
-		    pio_read_8(&cmd->cylinder_low);
-
-		if (bc == PDEV_SIGNATURE_BC) {
-			rc = identify_pkt_dev(disk_id, &idata);
-			if (rc == EOK) {
-				/* We have a packet device. */
-				d->dev_type = ata_pkt_dev;
-			} else {
-				return EIO;
-			}
+		rc = identify_pkt_dev(disk_id, &idata);
+		if (rc == EOK) {
+			/* We have a packet device. */
+			d->dev_type = ata_pkt_dev;
 		} else {
 			/* Nope. Something's there, but not recognized. */
@@ -417,4 +403,5 @@
 	}
 
+	printf("device caps: 0x%04x\n", idata.caps);
 	if (d->dev_type == ata_pkt_dev) {
 		/* Packet device */
@@ -579,9 +566,8 @@
 
 	/*
-	 * Do not wait for DRDY to be set in case this is a packet device.
-	 * We determine whether the device is present by waiting for DRQ to be
-	 * set after issuing the command.
+	 * This is where we would most likely expect a non-existing device to
+	 * show up by not setting SR_DRDY.
 	 */
-	if (wait_status(0, ~SR_BSY, NULL, TIMEOUT_PROBE) != EOK)
+	if (wait_status(SR_DRDY, ~SR_BSY, NULL, TIMEOUT_PROBE) != EOK)
 		return ETIMEOUT;
 
@@ -591,20 +577,15 @@
 		return ETIMEOUT;
 
-	/*
-	 * If ERR is set, this may be a packet device, so return EIO to cause
-	 * the caller to check for one.
-	 */
+	/* Read data from the disk buffer. */
+
+	if ((status & SR_DRQ) != 0) {
+		for (i = 0; i < identify_data_size / 2; i++) {
+			data = pio_read_16(&cmd->data_port);
+			((uint16_t *) buf)[i] = data;
+		}
+	}
+
 	if ((status & SR_ERR) != 0) {
 		return EIO;
-	}
-
-	if (wait_status(SR_DRQ, ~SR_BSY, &status, TIMEOUT_PROBE) != EOK)
-		return ETIMEOUT;
-
-	/* Read data from the disk buffer. */
-
-	for (i = 0; i < identify_data_size / 2; i++) {
-		data = pio_read_16(&cmd->data_port);
-		((uint16_t *) buf)[i] = data;
 	}
 
